﻿using System;
using System.Windows.Data;

namespace XamGridGroupByPerfTest {

    public class DoubleStringViewConverter : IValueConverter {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture) {
            var dValue = ((CellValue)value).ActualValue;
            return double.IsNaN(dValue) ? "" : string.Format("{0:N2}", dValue);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture) {
            var sValue = ((string)value).Trim();

            return sValue == string.Empty ? double.NaN : double.Parse(sValue);
        }
    }
}
