﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace XamGridGroupByPerfTest {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged {

        public MainWindow() {
            Items = new ObservableCollection<Element>(GetElements());

            InitializeComponent();

            var firstColumn = new TextColumn() {
                Key = "Name",
                Width = ColumnWidth.Auto,
                MinimumWidth = 32,
            };

            Grid.Columns.Add(firstColumn);


            for (var idx = 0; idx < 50; idx++) {
                var key = string.Format("[{0}]", idx);
                var header = idx.ToString(CultureInfo.InvariantCulture);

                var column = new TextColumn() {
                    Key = key,
                    Tag = idx,
                    ConditionalFormatCollection = new ConditionalFormatCollection() {
                         new MyCondition()
                    },
                    //AllowToolTips = AllowToolTips.Always,
                    HeaderText = header,
                    Width = ColumnWidth.Auto,
                    MinimumWidth = 32,
                    ValueConverter = new DoubleStringViewConverter(),
                    EditorValueConverter = new DoubleStringEditConverter(idx)

                };

                Grid.Columns.Add(column);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName) {
            var handler = PropertyChanged;

            if (null != handler) {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }


        ObservableCollection<Element> _items;
        public ObservableCollection<Element> Items {
            get {
                return _items;
            }
            set {
                _items = value;
                OnPropertyChanged("Items");
            }
        }

        IEnumerable<Element> GetElements() {
            var count = 10000;
            while (count-- > 0) {
                var result = new Element {
                    Name = "first 10k"
                };

                yield return result;
            }
        }



        private void ButtonBase_OnClick(object sender, RoutedEventArgs e) {
            var count = 5000;
            while (count-- > 0) {
                var result = new Element() {
                    Name = "next 5k"
                };

                Items.Add(result);
            }
        }












    }
}
