﻿using System;
using System.Collections.Generic;
using System.Diagnostics.SymbolStore;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Media;
using Infragistics.Controls.Grids;

namespace XamGridGroupByPerfTest {
    class MyCondition : ConditionalFormattingRuleBase {
      
        protected override IConditionalFormattingRuleProxy CreateProxy() {
            return new MyConditionalFormatRuleProxy();
        }
    }

     public class MyConditionalFormatRuleProxy : ConditionalFormattingRuleBaseProxy{

         Style BasicCellStyle {
             get {
                 return (Style)Application.Current.MainWindow.Resources["BasicCellStyle"];
             }
         }

         Style BasicCellStyleOrange {
             get {
                 return (Style)Application.Current.MainWindow.Resources["BasicCellStyleOrange"];
             }
         }

         Style IhsGridCellFormatting {
             get {
                 return (Style)Application.Current.MainWindow.Resources["IhsGridCellFormatting"];
             }
         }

         

        protected override System.Windows.Style EvaluateCondition(object sourceDataObject, object sourceDataValue) {
            CellValue d = (CellValue)sourceDataValue;
            var style = IhsGridCellFormatting;


            var result = new Style(typeof(CellControl), style);

            if (d.IsGreaterThanZero) {
                result.Setters.Add(new Setter(TextElement.ForegroundProperty, new SolidColorBrush(Colors.GreenYellow)));
            }
    
            
            return result;


        }
    }


 }

